////////////////////////////////////////////////////////////////////////////
// Atol file manager project <http://atol.sf.net>
//
// This code is licensed under BSD license.See "license.txt" for more details.
//
// File: Implements archive description object and the list of such objects
////////////////////////////////////////////////////////////////////////////

#ifndef ARCHIVEINFO_H_
#define ARCHIVEINFO_H_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#if _MSC_VER > 1000
 #pragma warning (disable : 4786)
#endif

#include "../plugin_defs.h"
#include "gzip.h"

#include <map>
#include <string>


//
//	store single archive data
//	(one for each archive opened by this plugin)
//

class CArchiveInfo
{
public:
	CArchiveInfo();
	~CArchiveInfo();

	CGZip	m_objGzip;

	int    m_dwID;
	void  *m_hArchive;

	std::string m_strFile;
	std::string m_strCurEntry;

	bool	m_bGzListed;
	bool	m_bUnpacking;
	int		m_nProgressPos;
	long	m_dwUserData;
	tProcessDataProc m_pfnProgress;
};

typedef CArchiveInfo *AAA;
typedef std::map<int, AAA> tOpenArchiveMap;

//
//	list of opened archive descriptions
//	(each archive is mapped to its unique ID number)
//
class COpenArchivesList : protected tOpenArchiveMap
{
public:
	COpenArchivesList();
	~COpenArchivesList();

	void Clear();
	int   Add(CArchiveInfo *pInfo);
	bool  Remove(int dwID);
	void  RemoveAll();

	bool IdExists(int dwID);
	CArchiveInfo *Find(int dwID);
};

#endif // ARCHIVEINFO_H_

